
/*
 *  milk-dashboard.js
 *  Milk
 *
 *  Created by Diego Belfiore
 *  Copyright (c) 2013 Tatami Software. All rights reserved.
 */


function appendPostHtml(htmlToAppend) {
    $('#mt-posts-container').append(htmlToAppend);
    showLoadingIndicator();
}

function prependPostHtml(htmlToPrepend) {
    $('#mt-posts-container').prepend(htmlToPrepend);
    showLoadingIndicator();
}

function prependDraftedPosts(postsToPrepend) {
    $('#mt-drafts-posts-container').prepend(postsToPrepend);
}

function prependQueuedPosts(postsToPrepend) {
    $('#mt-queued-posts-container').prepend(postsToPrepend);
}

function prependPublishedPosts(postsToPrepend) {
    $('#mt-published-posts-container').prepend(postsToPrepend);
}

function isPostLiked(postId) {
    var postLikeButton = "#post_" + postId + "_likebutton";
    return $(postLikeButton).hasClass('mt-unlike-button');
}

function markPostAsLiked(postId) {
    var buttonId = "#post_" + postId + "_likebutton";
    $(buttonId).removeClass('mt-like-button');
    $(buttonId).addClass('mt-unlike-button');
}

function markPostAsUnliked(postId) {
    var buttonId = "#post_" + postId + "_likebutton";
    $(buttonId).removeClass('mt-unlike-button');
    $(buttonId).addClass('mt-like-button');
}

function replacePost(postId, replacementPost) {
    var postDiv = "#post_" + postId;
    $(postDiv).replaceWith(replacementPost);
}

function removePost(postId) {
    var postDiv = "#post_" + postId;
    $(postDiv).hide('medium', function() { 
                    $(postDiv).remove();
                    });
}

function unfoldPostBody(postId) {
    var postDiv = "#mt-folded-text_" + postId;
    var readMoreButton = "#mt-read-more_" + postId;
    $(postDiv).show('medium', function () {
        $(readMoreButton).hide();
    });
}

function reloadVideoDivs() {
    /* jquery snippet courtesy of http://bit.ly/hDegY1 */
    $( 'iframe' ).attr( 'src', function ( i, val ) { return val; });

    /* a little more magic required for 'embed' tags for some reason. */
    $( 'embed' ).parent().html(function(i, val) { return val; });
}

function hideLoadingIndicator() {
    $("#loading-gif").hide();
}

function showLoadingIndicator() {
    $("#loading-gif").show();
}

function moveCarouselForward() {
    $("#mt-carousel-move-right").click();
}

function moveCarouselBackward() {
    $("#mt-carousel-move-left").click();
}

function addStylesheet(stylesheet) {
    $('head').append('<link rel="stylesheet" type="text/css" href="' + stylesheet + '">');
}

function removeStylesheet(stylesheet) {
    $('link[href="' + stylesheet + '"]').attr('disabled', 'disabled');
    $('link[href="' + stylesheet + '"]').remove();
}

$(document).ready(function() {                  
                  
                  /* Courtesy of John Resig: http://ejohn.org/blog/learning-from-twitter/ & http://bit.ly/cc4xqN */
                  
                  var didScroll = false;
                  
                  $(window).scroll(function() {
                                       didScroll = true;
                                   });
                  
                  setInterval(function() {
                                  if (didScroll) {
                                      didScroll = false;
                                      if($(window).scrollTop() + $(window).height() > $(document).height() - 500) {
                                          window.MTDashboardController.loadMorePosts();
                                      }
                                  }
                              }, 250);
                  });